import java.io.*;
import java.util.*;

public class unlucky_md implements Runnable {
	private Scanner in;
	private PrintWriter out;
	private final int dig = 10;
	
	int n, mod;
	int[][] c;
	int[] a;
	boolean[][] p;
	int answer;
	int parts;

	private void solve() {
		n = in.nextInt();
		mod = in.nextInt();
		cnk();
		a = new int[dig];
		p = new boolean[n / 2 + 1][n / 2 * (dig - 1) + 1];
		answer = 0;
		parts = 0;
		go(0, 0, 1, 0);
		out.println(answer);
		System.out.println(parts + " partitions");
	}

	private void go(int i, int put, int amount, int sum) {
		if (i == dig) {
			if (put != n)
				return;
//			parts++;
			if (sum % 2 == 1 || !happy(sum)) {
				answer += amount;
				answer %= mod;
//			} else {
//				System.out.println(Arrays.toString(a) + " " + amount);
			}
			return;
		}
		for (int m = 0; put + m <= n; m++) {
			a[i] = m;
			go(i + 1, put + m, (int) ((long) amount * c[n - put][m] % mod), sum + i * m);
		}
	}

	private boolean happy(int sum) {
		parts++;
		for (int i = 0; i <= n / 2; i++) {
			Arrays.fill(p[i], false);
		}
		p[0][0] = true;
		for (int d = 0; d < dig; d++) {
			for (int j = 0; j < a[d]; j++) {
				for (int i = n / 2 - 1; i >= 0; i--) {
					for (int k = 0; k <= i * (dig - 1); k++) {
						p[i + 1][k + d] |= p[i][k];
					}
				}
			}
		}
		return p[n / 2][sum / 2];
	}

	private void cnk() {
		c = new int[n + 1][n + 1];
		for (int i = 0; i <= n; i++) {
			c[i][0] = c[i][i] = 1;
			for (int j = 1; j < i; j++) {
				c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % mod;
			}
		}
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new Thread(new unlucky_md()).start();
	}

	public void run() {
		try {
			in = new Scanner(new FileReader("unlucky.in"));
			out = new PrintWriter("unlucky.out");
			solve();
			in.close();
			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
