#include <cmath>
#include <cstdio>
#include <cstring>

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define maxn 103
#define msum 1010

typedef long long ll;

int N, K, a[maxn], num[10], is[msum];
ll sum, tmp, fact[maxn];

void Gen( int n, int mi, int ss )
{
  if (n == N)
  {
    if (ss & 1)
      return;

    forn(i, ss + 1)
      is[i] = 0;
    is[0] = 1;

    int s = 0;
    forn(i, N)
    {
      if (is[ss / 2])
        break;
      for (int j = s; j >= 0; j--)
        if (is[j])
          is[j + a[i]] = 1;
      s += a[i];
    }

    if (is[ss / 2])
    {
      tmp = 1;
      
      int rest = N;
      forn(i, K + 1)
        forn(j, num[i])
        {
          tmp *= rest--;
          tmp /= j + 1;
        }
      sum += tmp;
    }

    return;
  }

  for (int i = mi; i <= K; i++)
  {
    a[n] = i;
    num[i]++;
    Gen(n + 1, i, ss + i);
    num[i]--;
  }  
}

int main()
{
  freopen("unlucky.in", "rt", stdin);
  freopen("unlucky.out", "wt", stdout);

  while (scanf("%d%d", &N, &K) == 2 && (N || K))
  {
    memset(num, 0, sizeof(num));
    sum = 0;
    fact[0] = 1;
    for (int i = 1; i < maxn; i++)
      fact[i] = i * fact[i - 1];
    Gen(0, 0, 0);
    fprintf(stderr, "%d,%d --> %I64d\n", N, K, (ll)(pow(K + 1, N) + 0.5) - sum);
    printf("%I64d\n", (ll)(pow(K + 1, N) + 0.5) - sum);
  }
  return 0;
}
